-- Euphoria 3.0
-- Additional functions

-- Created by: Vincent Howell
-- Date: February 5, 2006

global function absolute_path(sequence path)
    return find(path[1], SLASH_CHARS) or
	(not ELINUX and find(':', path))
end function

global function remove_trail(sequence gtext)
-- remove any excess slash trails
    sequence slash
    boolean block

    slash = ""
    block = FALSE

    for i = 1 to length(gtext) do
	if find(gtext[i], "\\/") then
	    gtext[i] = SLASH
	    if not block then
		slash &= gtext[i]
		block = TRUE
	    end if
	else
	    slash &= gtext[i]
	    block = FALSE
	end if
    end for

    return slash
end function

global function trim_name(sequence name)
-- trim off file names from paths
    sequence clean_name, loc_slash

    clean_name = {}
    loc_slash = {}

    for i = 1 to length(name) do
	clean_name &= name[i]
	if name[i] = SLASH then
	    loc_slash &= i
	end if
    end for

    if length(loc_slash) > 1 then
	clean_name = clean_name[1..loc_slash[$]-1]
    elsif length(loc_slash) = 1 then
	clean_name = clean_name[1..loc_slash[$]]
    end if

    return clean_name
end function

global function resolve_dots(sequence gtext, sequence dir)
-- scan dots and adjust file path
    sequence dots, dot, scan, slashes
    boolean block, dotfound
    atom counter

    dotfound = FALSE
    block = FALSE
    counter = 0
    slashes = {}
    scan = {}
    dots = {}
    dot = {}

    if length(gtext) >= 1 then
	if gtext[1] = '.' then
	    dotfound = TRUE
	    for i = 1 to length(gtext) do
		if gtext[i] = '.' then
		    dot = append(dot, gtext[i])
		elsif gtext[i] = SLASH then
		    if not equal(dot, {}) then
			dots = append(dots, dot)
		    end if
		    dot = {}
		end if

		if not block then
		    if not (gtext[i] = '.' or gtext[i] = SLASH) then
			scan &= gtext[i]
			block = TRUE
		    end if
		else
		    scan &= gtext[i]
		end if
	    end for

	    for j = 1 to length(dots) do
		if equal(dots[j], "..") then
		    counter += 1
		end if
	    end for

	    for k = length(dir) to 1 by -1 do
		if dir[k] = '\\' or dir[k] = '/' then
		    slashes = append(slashes, k)
		end if
	    end for

	    if counter >= 1 then
		if length(slashes) < counter then
		    counter = length(slashes)
		end if
		dir = dir[1..slashes[counter]]
	    end if
	end if
    end if

    if dir[$] != SLASH then
	dir = dir & SLASH
    end if

    if equal(scan, {}) then
	return ({dir} & {gtext} & {dotfound})
    else
	return ({dir} & {scan} & {dotfound})
    end if
end function
